
#    application: image filtering
#    state: experimental
#    revision: $Id: common_targets.mk,v 1.2 2005/06/29 15:52:25 tobias Exp $
# 
#    Metaprogramming Project
#    Authors: Christoph A. Herrmann and Tobias Langhammer
#    University of Passau, Department of Informatics, Chair of Programming

##############################################################################
#
# Copyright (C) 2005 University of Passau, Department of Informatics
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################


 
%.cmi: %.mli
	$(OCAMLC) $(OCAMLFLAGS) -c  $<

%.cmo: %.ml %.cmi
	$(OCAMLC) $(OCAMLFLAGS) -c  $<
 
main.cmx filt_lexer.cmx:%.cmx: %.ml
	$(OCAMLOPT) $(OCAMLFLAGS) -c $<
	
main.cmo filt_lexer.cmo:%.cmo: %.ml
	$(OCAMLC) $(OCAMLFLAGS) -c  $<

%.cmx: %.ml %.cmi
	$(OCAMLOPT) $(OCAMLFLAGS) -c $<


-include deps

	

config_unstaged.m4 config_staged.m4: config.m4



$(BORN_FROM_NOTHING):
	touch $@

.PHONY: clean distclean doc

clean:
	rm -f *~ a.out depend $(GENERATED_FILES)
	rm -rf .xvpics

distclean: clean
	rm -rf imagefilter saved_csp_array


$(MLI_FILES) $(ML_FILES) $(M4_FILES) $(TEST_FILES):%:../src/%
	cp ../src/$@ .

depend: $(MLI_FILES) $(ML_FILES) $(M4_FILES)
	echo 'm4 $$@ | sed -e "s/>\./)/g;s/\.</(/g;s/\.[!~]/ /g"' > /tmp/__specialpp.sh
	$(OCAMLDEP) $(OCAMLFLAGS) -pp 'sh /tmp/__specialpp.sh' $^ > deps
	rm /tmp/__specialpp.sh

test: depend $(CMO_FILES) $(TEST_FILES)
	expect test_inter.expect
	





