(*

  application: image filtering
  state: experimental
  revision: $Id: stagedinter.mli,v 1.2 2005/06/21 11:39:41 tobias Exp $
 
  Metaprogramming Project
  Authors: Christoph A. Herrmann and Tobias Langhammer
  University of Passau, Department of Informatics, Chair of Programming

 Copyright (C) 2004    University of Passau, Department of Informatics
 
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*)

type 'a codevalue                                           (* __only_staged__ *)
val interp : int ->                                         (* __only_staged__ *)
  'a codevalue Defs.environment ->                          (* __only_staged__ *)
  Defs.top_exp -> Ppm.image -> ('a, int * int -> int array ) code  (* __only_staged__ *)

val codegen_top_exp : Defs.top_exp ->   (* __only_staged__*)
  'a codevalue Defs.environment ->          (* __only_staged__*)
  Ppm.image -> ('a, int list) code  (* __only_staged__*)

val compile : bool -> bool -> int -> Defs.top_exp -> Ppm.image -> 
  int * int -> Ppm.point
